#!/bin/bash
#
############################################################################################################################
# Nom: Report_CUPS.sh                                                                                                      #
# Descripció: Report_CUPS.sh permet accedir de forma gràfica a les estadístiques generades per l'script PrintAnalyzer.     #
# Llicència: GPL v2.0                                                                                                      #
# Autor: Joan de Gracia. Servei TAC. Departament d'Ensenyament                                                             #
# Versió: 1.1                                                                                                              #
# Data: 10-01-2018                                                                                                         #
#                                                                                                                          #
# El programa PrintAnalyzer permet generar estadístiques del fitxer page_log del sistema d'impressió CUPS.                 #
# PrintAnalyzer es distribueix sota llicència GNU GPL 2.0 o superior.                                                      #
# L'autor del programa PrintAnalyzer és Thies Moeller i es pot descarregar des de la URL:                                  #
#	http://download-mirror.savannah.gnu.org/releases//printanalyze/PrintAnalyzer                                           #
#                                                                                                                          #
############################################################################################################################

zenity --info --width=250 --text="Aquest programa analitza les impressions fetes pel sistema CUPS."
LOG_CUPS=""
while [ "$LOG_CUPS" == "" ]; do
         LOG_CUPS=$(zenity --entry --width=200 --text="Introdueixi el nom i la ruta cap al fitxer page_log del sistema CUPS \n\r \
(Podeu deixar el valor predeterminat)" --entry-text="/var/log/cups/page_log")
	if [ "$LOG_CUPS" == "" ]; then
           zenity --info --width=200 --text "Informe cancel·lat" --title='Informació'
	   exit 0;
	fi
	if [ ! -f $LOG_CUPS ]; then
		LOG_CUPS=""
	fi
done
FITXER_TMP=$(mktemp)
PRINTANALYZER=/usr/share/reportcups-1.0/PrintAnalyzer
PERL=$(which perl)
RM=$(which rm)
MV=$(which mv)
XDG_USER_DIR=$(which xdg-user-dir)
ESCRIPTORI=$($XDG_USER_DIR DESKTOP)
CP=$(which cp)
DATA=$(which date)
HORA=$($DATA +%F_%H\:%M)
PREFIX="CUPS_"
FITXER_REPORT=$PREFIX$HORA.txt
DOS2UNIX=$(which dos2unix)
echo -e "Informe generat en data: $HORA \r\n" >>$FITXER_TMP
$PERL $PRINTANALYZER -f $LOG_CUPS | sed 's/\f//' >> $FITXER_TMP
$DOS2UNIX -n $FITXER_TMP /tmp/$FITXER_REPORT
$GEDIT=$(which gedit)
zenity --question \
       --text="Voleu desar l'informe del servei d'impressió CUPS?" \
       --title="Pregunta" \
       --ok-label="Sí" \
       --cancel-label="No" \
       --width=200
       
      if [ "$?" == "0" ]; then
      {
	     $CP /tmp/$FITXER_REPORT $ESCRIPTORI/$FITXER_REPORT     
	     GRUP_USUARI_SUDOER=$(id -g $SUDO_USER)	 
	     chown $SUDO_USER:$GRUP_USUARI_SUDOER $ESCRIPTORI/$FITXER_REPORT
	     chmod 644 $ESCRIPTORI/$FITXER_REPORT
         zenity --info --width=200 --text "Informe desat a l'escriptori amb el nom:\n\n $FITXER_REPORT" --title='Informació'
      }
      else
      {
         zenity --info --width=200 --text "Informe no desat" --title='Informació'
      }
      fi
$RM $FITXER_TMP
$RM /tmp/$FITXER_REPORT
